<!DOCTYPE html>
<html lang="pt-br">
  <head>
    <title>vsftpd</title>
    <meta charset="utf-8">
    <link rel="stylesheet" href="https://bootswatch.com/4/slate/bootstrap.min.css" crossorigin="anonymous">
  </head>
  <body>
    <div class="container mt-4">
      <div class="text-center">
        <h1>vsftpd</h1>
      </div>
        <h2>Instalação</h2>
        <p>
            A configuração do vsftpd é feita juntamente a partir do manifesto principal, encontrado em <code>manifests/default.pp</code>. Nele, é definido a variável PATH do sistema, executado o comando <code>apt-get update</code> do sistema, instalado os pacotes <code>nginx</code> e <code>vsftpd</code>. Então é copiado este arquivo de instruções para a pasta pública do NGINX, e o arquivo de configurações do vsftpd para <code>/etc/vsftpd.conf</code>, então este último é reiniciado. Por fim, executado o serviço <code>nginx</code>.
        </p>
        <p>
            Veja o código fonte do manifesto principal <code>manifests/default.pp</code>:
        </p>
        <pre><code>
            # Define o PATH do sistema
            Exec { path => [ "/usr/bin:/usr/sbin:/bin:/usr/local/bin:/usr/local/sbin:/sbin" ] }

            # Instala o pacote vsftpd após garantir que a lista de pacotes está atualizada
            package { ['vsftpd' ]:
              require => Class["system-update"],
              ensure  => 'installed',
            }

            # Copia os arquivos de README para raiz /var/www/
            exec {"copia_readme":
                 command => "sudo cp /vagrant/README.html /usr/share/nginx/www/index.html",
                onlyif => ['ls -l /vagrant/README.html'],
                require => Package["nginx"]
            }

            # Copia os arquivos de configuração do servidor FTP & Reinicia-o
            exec {"copia_config":
                command => "sudo cp -rf /vagrant/vsftpd.conf /etc/vsftpd.conf; sudo restart vsftpd",
                onlyif => ['ls -l /etc/vsftpd.conf'],
                require => Package["vsftpd"]
            }

            # Certifica-se que os serviços nginx está em execução
            service { "nginx":
              ensure  => "running",
              require => Package["nginx"],
            }

            # Instala o módulo system-update
            include system-update
        </code></pre>
        <br>
        A configuração personalizada do vsftpd comenta o comando <code>anonymous_enable=NO</code> e habilita <code>write_enable=YES</code>.

        O usuário e senha para acesso ao FTP em <code>ftp://192.168.33.16</code> é <code>vagrant</code>.
    </div>
  </body>
</html>